(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms')) :
    typeof define === 'function' && define.amd ? define('@sirusdev/canvas-input-angular', ['exports', '@angular/core', '@angular/forms'], factory) :
    (global = global || self, factory((global.sirusdev = global.sirusdev || {}, global.sirusdev['canvas-input-angular'] = {}), global.ng.core, global.ng.forms));
}(this, (function (exports, core, forms) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var VECTOR_X = 0;
    var VECTOR_Y = 1;
    var VECTOR_DRAG = 2;
    var VECTOR_SIZE = 3;
    var VECTOR_COLOR = 4;
    var VECTOR_OPACITY = 5;
    var defaultCanvasModel = {
        width: 500,
        height: 800,
        vectors: [],
        imgUrl: '',
    };
    var CanvasInputComponent = /** @class */ (function () {
        function CanvasInputComponent() {
            this.color = '#ff0000';
            this.size = 5; // natural numbers
            this.opacity = 1; // 0-1 intervals
            this.offsetTop = 0;
            this.offsetLeft = 0;
            this.paint = false;
            this.width = 400;
            this.height = 400;
            this.vectors = []; // [x, y, drag, size, color, opacity]
            this.imgLoaded = false;
            this.disabled = false;
            this.viewInitiated = false;
            this.onChangeListeners = [];
            this.onBlurListeners = [];
        }
        CanvasInputComponent_1 = CanvasInputComponent;
        CanvasInputComponent.prototype.ngAfterViewInit = function () {
            var _this = this;
            this.paper = this.paperRef.nativeElement;
            this.ctx = this.paper.getContext('2d');
            if (!this.ctx) {
                throw new Error('browser not supporting canvas');
            }
            this.paper.ontouchstart = function (e) { return _this.onTouchStart(e); };
            this.paper.onmousedown = function (e) { return _this.onMouseDown(e); };
            this.paper.onmousemove = function (e) { return _this.onMouseMove(e); };
            this.paper.ontouchmove = function (e) { return _this.onTouchMove(e); };
            this.paper.ontouchend = function (e) { return _this.disablePaint(e); };
            this.paper.onmouseup = function (e) { return _this.disablePaint(e); };
            this.paper.onmouseleave = function (e) { return _this.disablePaint(e); };
            this.viewInitiated = true;
            // draw image & vectors
            this.registerOnChange(function (val) { return _this.writeValue(val); });
        };
        // clean ups
        CanvasInputComponent.prototype.ngOnDestroy = function () {
            this.onChangeListeners = [];
            this.onBlurListeners = [];
            this.paper.ontouchstart = null;
            this.paper.onmousedown = null;
            this.paper.onmousemove = null;
            this.paper.ontouchmove = null;
            this.paper.ontouchend = null;
            this.paper.onmouseup = null;
            this.paper.onmouseleave = null;
        };
        /**
         * Writes a new value to the element.
         *
         * This method is called by the forms API to write to the view when programmatic
         * changes from model to view are requested.
         */
        CanvasInputComponent.prototype.writeValue = function (value) {
            var _a;
            if (!value) {
                return null;
            }
            if (this.width !== value.width) {
                this.width = value.width;
                this.paper.width = this.width;
            }
            if (this.height !== value.height) {
                this.height = value.height;
                this.paper.height = this.height;
            }
            this.vectors = value.vectors;
            this.imgUrl = value.imgUrl;
            if (((_a = this.img) === null || _a === void 0 ? void 0 : _a.src) !== value.imgUrl) {
                this.loadImage();
            }
            this._reDraw();
        };
        CanvasInputComponent.prototype.loadImage = function () {
            var _this = this;
            var _a;
            if (!this.viewInitiated) {
                return null;
            }
            if (!((_a = this.imgUrl) === null || _a === void 0 ? void 0 : _a.length)) {
                return null;
            }
            var w = this.width;
            var h = this.height;
            this.imgLoaded = false;
            this.img = new Image();
            this.img.onload = function () {
                _this.imgLoaded = true;
                _this.ctx.drawImage(_this.img, 0, 0, w, h);
            };
            this.img.src = this.imgUrl;
        };
        /**
         * Registers a callback function that is called when the control's value
         * changes in the UI.
         *
         * This method is called by the forms API on initialization to update the form
         * model when values propagate from the view to the model.
         */
        CanvasInputComponent.prototype.registerOnChange = function (fn) {
            if (!fn) {
                return null;
            }
            this.onChangeListeners.push(fn);
        };
        /**
         * Registers a callback function is called by the forms API on initialization
         * to update the form model on blur.
         */
        CanvasInputComponent.prototype.registerOnTouched = function (fn) {
            if (!fn) {
                return null;
            }
            this.onBlurListeners.push(fn);
        };
        /**
         * Function that is called by the forms API when the control status changes to
         * or from 'DISABLED'. Depending on the status, it enables or disables the
         * appropriate DOM element.
         */
        CanvasInputComponent.prototype.setDisabledState = function (isDisabled) {
            this.disabled = isDisabled;
        };
        CanvasInputComponent.prototype.onMouseDown = function (e) {
            if (this.disabled) {
                return null;
            }
            e.preventDefault();
            var x = e.pageX - this.paper.offsetLeft + this.offsetLeft;
            var y = e.pageY - this.paper.offsetTop + this.offsetTop;
            this.paint = true;
            this.addPoint(x, y);
        };
        CanvasInputComponent.prototype.onTouchStart = function (e) {
            if (this.disabled) {
                return null;
            }
            e.preventDefault();
            var x = e.touches[0].pageX - this.paper.offsetLeft + this.offsetLeft;
            var y = e.touches[0].pageY - this.paper.offsetTop + this.offsetTop;
            this.paint = true;
            this.addPoint(x, y);
        };
        CanvasInputComponent.prototype.onMouseMove = function (e) {
            if (this.disabled) {
                return null;
            }
            e.preventDefault();
            if (!this.paint) {
                return null;
            }
            var x = e.pageX - this.paper.offsetLeft + this.offsetLeft;
            var y = e.pageY - this.paper.offsetTop + this.offsetTop;
            this.addPoint(x, y, true);
        };
        CanvasInputComponent.prototype.onTouchMove = function (e) {
            if (this.disabled) {
                return null;
            }
            e.preventDefault();
            if (!this.paint) {
                return null;
            }
            var x = e.touches[0].pageX - this.paper.offsetLeft + this.offsetLeft;
            var y = e.touches[0].pageY - this.paper.offsetTop + this.offsetTop;
            this.addPoint(x, y, true);
        };
        CanvasInputComponent.prototype.disablePaint = function (e) {
            var _a;
            e.preventDefault();
            this.paint = false;
            // update on blur handler
            var $event = {
                width: this.width,
                height: this.height,
                vectors: __spread(this.vectors),
                imgUrl: (_a = this.img) === null || _a === void 0 ? void 0 : _a.src,
            };
            this.onBlurListeners.forEach(function (fn) { return fn($event); });
        };
        CanvasInputComponent.prototype.addPoint = function (x, y, drag) {
            if (drag === void 0) { drag = false; }
            var _a;
            var size = this.size;
            var color = this.color;
            var opacity = this.opacity;
            this.vectors.push([x, y, drag, size, hexToRgb(color), opacity]);
            var $event = {
                width: this.width,
                height: this.height,
                vectors: __spread(this.vectors),
                imgUrl: (_a = this.img) === null || _a === void 0 ? void 0 : _a.src,
            };
            this.onChangeListeners.forEach(function (fn) { return fn($event); });
        };
        CanvasInputComponent.prototype._reDraw = function () {
            if (!this.viewInitiated) {
                return null;
            }
            var w = this.width;
            var h = this.height;
            this.ctx.clearRect(0, 0, w, h);
            if (this.imgLoaded) {
                this.ctx.drawImage(this.img, 0, 0, w, h);
            }
            this.ctx.lineJoin = 'round';
            for (var i = 0; i < this.vectors.length; i++) {
                this.ctx.beginPath();
                if (this.vectors[i][VECTOR_DRAG] && i > 0) {
                    this.ctx.moveTo(this.vectors[i - 1][VECTOR_X], this.vectors[i - 1][VECTOR_Y]);
                }
                else {
                    this.ctx.moveTo(this.vectors[i][VECTOR_X] - 1, this.vectors[i][VECTOR_Y]);
                }
                this.ctx.lineTo(this.vectors[i][VECTOR_X], this.vectors[i][VECTOR_Y]);
                this.ctx.closePath();
                var _a = this.vectors[i][VECTOR_COLOR], r = _a.r, g = _a.g, b = _a.b;
                this.ctx.strokeStyle = "rgba(" + r + ", " + g + ", " + b + ", " + this.vectors[i][VECTOR_OPACITY] + ")";
                this.ctx.lineWidth = this.vectors[i][VECTOR_SIZE];
                this.ctx.stroke();
            }
        };
        var CanvasInputComponent_1;
        __decorate([
            core.Input()
        ], CanvasInputComponent.prototype, "color", void 0);
        __decorate([
            core.Input()
        ], CanvasInputComponent.prototype, "size", void 0);
        __decorate([
            core.Input()
        ], CanvasInputComponent.prototype, "opacity", void 0);
        __decorate([
            core.Input()
        ], CanvasInputComponent.prototype, "offsetTop", void 0);
        __decorate([
            core.Input()
        ], CanvasInputComponent.prototype, "offsetLeft", void 0);
        __decorate([
            core.ViewChild('paper')
        ], CanvasInputComponent.prototype, "paperRef", void 0);
        CanvasInputComponent = CanvasInputComponent_1 = __decorate([
            core.Component({
                selector: 'sirus-canvas-input',
                template: "<canvas #paper></canvas>\r\n",
                providers: [
                    {
                        provide: forms.NG_VALUE_ACCESSOR,
                        useExisting: core.forwardRef(function () { return CanvasInputComponent_1; }),
                        multi: true,
                    },
                ]
            })
        ], CanvasInputComponent);
        return CanvasInputComponent;
    }());
    // hexToRgb will convert hex to RGB color format
    function hexToRgb(hex) {
        var result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
        return result
            ? {
                r: parseInt(result[1], 16),
                g: parseInt(result[2], 16),
                b: parseInt(result[3], 16),
            }
            : null;
    }

    var CanvasInputModule = /** @class */ (function () {
        function CanvasInputModule() {
        }
        CanvasInputModule = __decorate([
            core.NgModule({
                declarations: [CanvasInputComponent],
                imports: [forms.FormsModule],
                exports: [CanvasInputComponent],
            })
        ], CanvasInputModule);
        return CanvasInputModule;
    }());

    exports.CanvasInputComponent = CanvasInputComponent;
    exports.CanvasInputModule = CanvasInputModule;
    exports.defaultCanvasModel = defaultCanvasModel;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=sirusdev-canvas-input-angular.umd.js.map
